/**
 * Autogenerated by Thrift Compiler (0.10.0)
 *
 * DO NOT EDIT UNLESS YOU ARE SURE THAT YOU KNOW WHAT YOU ARE DOING
 *  @generated
 */
#ifndef ClientService_H
#define ClientService_H

#include <thrift/TDispatchProcessor.h>
#include <thrift/async/TConcurrentClientSyncInfo.h>
#include "Service_types.h"

namespace chatgen {

#ifdef _WIN32
  #pragma warning( push )
  #pragma warning (disable : 4250 ) //inheriting methods via dominance 
#endif

class ClientServiceIf {
 public:
  virtual ~ClientServiceIf() {}
  virtual void IncomingMessage(const std::string& message, const std::string& senderName, const bool isBroadcast) = 0;
  virtual void UserConnected(const std::string& userName) = 0;
  virtual void UserDisconnected(const std::string& userName) = 0;
};

class ClientServiceIfFactory {
 public:
  typedef ClientServiceIf Handler;

  virtual ~ClientServiceIfFactory() {}

  virtual ClientServiceIf* getHandler(const ::apache::thrift::TConnectionInfo& connInfo) = 0;
  virtual void releaseHandler(ClientServiceIf* /* handler */) = 0;
};

class ClientServiceIfSingletonFactory : virtual public ClientServiceIfFactory {
 public:
  ClientServiceIfSingletonFactory(const boost::shared_ptr<ClientServiceIf>& iface) : iface_(iface) {}
  virtual ~ClientServiceIfSingletonFactory() {}

  virtual ClientServiceIf* getHandler(const ::apache::thrift::TConnectionInfo&) {
    return iface_.get();
  }
  virtual void releaseHandler(ClientServiceIf* /* handler */) {}

 protected:
  boost::shared_ptr<ClientServiceIf> iface_;
};

class ClientServiceNull : virtual public ClientServiceIf {
 public:
  virtual ~ClientServiceNull() {}
  void IncomingMessage(const std::string& /* message */, const std::string& /* senderName */, const bool /* isBroadcast */) {
    return;
  }
  void UserConnected(const std::string& /* userName */) {
    return;
  }
  void UserDisconnected(const std::string& /* userName */) {
    return;
  }
};

typedef struct _ClientService_IncomingMessage_args__isset {
  _ClientService_IncomingMessage_args__isset() : message(false), senderName(false), isBroadcast(false) {}
  bool message :1;
  bool senderName :1;
  bool isBroadcast :1;
} _ClientService_IncomingMessage_args__isset;

class ClientService_IncomingMessage_args {
 public:

  ClientService_IncomingMessage_args(const ClientService_IncomingMessage_args&);
  ClientService_IncomingMessage_args& operator=(const ClientService_IncomingMessage_args&);
  ClientService_IncomingMessage_args() : message(), senderName(), isBroadcast(0) {
  }

  virtual ~ClientService_IncomingMessage_args() throw();
  std::string message;
  std::string senderName;
  bool isBroadcast;

  _ClientService_IncomingMessage_args__isset __isset;

  void __set_message(const std::string& val);

  void __set_senderName(const std::string& val);

  void __set_isBroadcast(const bool val);

  bool operator == (const ClientService_IncomingMessage_args & rhs) const
  {
    if (!(message == rhs.message))
      return false;
    if (!(senderName == rhs.senderName))
      return false;
    if (!(isBroadcast == rhs.isBroadcast))
      return false;
    return true;
  }
  bool operator != (const ClientService_IncomingMessage_args &rhs) const {
    return !(*this == rhs);
  }

  bool operator < (const ClientService_IncomingMessage_args & ) const;

  uint32_t read(::apache::thrift::protocol::TProtocol* iprot);
  uint32_t write(::apache::thrift::protocol::TProtocol* oprot) const;

};


class ClientService_IncomingMessage_pargs {
 public:


  virtual ~ClientService_IncomingMessage_pargs() throw();
  const std::string* message;
  const std::string* senderName;
  const bool* isBroadcast;

  uint32_t write(::apache::thrift::protocol::TProtocol* oprot) const;

};

typedef struct _ClientService_UserConnected_args__isset {
  _ClientService_UserConnected_args__isset() : userName(false) {}
  bool userName :1;
} _ClientService_UserConnected_args__isset;

class ClientService_UserConnected_args {
 public:

  ClientService_UserConnected_args(const ClientService_UserConnected_args&);
  ClientService_UserConnected_args& operator=(const ClientService_UserConnected_args&);
  ClientService_UserConnected_args() : userName() {
  }

  virtual ~ClientService_UserConnected_args() throw();
  std::string userName;

  _ClientService_UserConnected_args__isset __isset;

  void __set_userName(const std::string& val);

  bool operator == (const ClientService_UserConnected_args & rhs) const
  {
    if (!(userName == rhs.userName))
      return false;
    return true;
  }
  bool operator != (const ClientService_UserConnected_args &rhs) const {
    return !(*this == rhs);
  }

  bool operator < (const ClientService_UserConnected_args & ) const;

  uint32_t read(::apache::thrift::protocol::TProtocol* iprot);
  uint32_t write(::apache::thrift::protocol::TProtocol* oprot) const;

};


class ClientService_UserConnected_pargs {
 public:


  virtual ~ClientService_UserConnected_pargs() throw();
  const std::string* userName;

  uint32_t write(::apache::thrift::protocol::TProtocol* oprot) const;

};

typedef struct _ClientService_UserDisconnected_args__isset {
  _ClientService_UserDisconnected_args__isset() : userName(false) {}
  bool userName :1;
} _ClientService_UserDisconnected_args__isset;

class ClientService_UserDisconnected_args {
 public:

  ClientService_UserDisconnected_args(const ClientService_UserDisconnected_args&);
  ClientService_UserDisconnected_args& operator=(const ClientService_UserDisconnected_args&);
  ClientService_UserDisconnected_args() : userName() {
  }

  virtual ~ClientService_UserDisconnected_args() throw();
  std::string userName;

  _ClientService_UserDisconnected_args__isset __isset;

  void __set_userName(const std::string& val);

  bool operator == (const ClientService_UserDisconnected_args & rhs) const
  {
    if (!(userName == rhs.userName))
      return false;
    return true;
  }
  bool operator != (const ClientService_UserDisconnected_args &rhs) const {
    return !(*this == rhs);
  }

  bool operator < (const ClientService_UserDisconnected_args & ) const;

  uint32_t read(::apache::thrift::protocol::TProtocol* iprot);
  uint32_t write(::apache::thrift::protocol::TProtocol* oprot) const;

};


class ClientService_UserDisconnected_pargs {
 public:


  virtual ~ClientService_UserDisconnected_pargs() throw();
  const std::string* userName;

  uint32_t write(::apache::thrift::protocol::TProtocol* oprot) const;

};

class ClientServiceClient : virtual public ClientServiceIf {
 public:
  ClientServiceClient(boost::shared_ptr< ::apache::thrift::protocol::TProtocol> prot) {
    setProtocol(prot);
  }
  ClientServiceClient(boost::shared_ptr< ::apache::thrift::protocol::TProtocol> iprot, boost::shared_ptr< ::apache::thrift::protocol::TProtocol> oprot) {
    setProtocol(iprot,oprot);
  }
 private:
  void setProtocol(boost::shared_ptr< ::apache::thrift::protocol::TProtocol> prot) {
  setProtocol(prot,prot);
  }
  void setProtocol(boost::shared_ptr< ::apache::thrift::protocol::TProtocol> iprot, boost::shared_ptr< ::apache::thrift::protocol::TProtocol> oprot) {
    piprot_=iprot;
    poprot_=oprot;
    iprot_ = iprot.get();
    oprot_ = oprot.get();
  }
 public:
  boost::shared_ptr< ::apache::thrift::protocol::TProtocol> getInputProtocol() {
    return piprot_;
  }
  boost::shared_ptr< ::apache::thrift::protocol::TProtocol> getOutputProtocol() {
    return poprot_;
  }
  void IncomingMessage(const std::string& message, const std::string& senderName, const bool isBroadcast);
  void send_IncomingMessage(const std::string& message, const std::string& senderName, const bool isBroadcast);
  void UserConnected(const std::string& userName);
  void send_UserConnected(const std::string& userName);
  void UserDisconnected(const std::string& userName);
  void send_UserDisconnected(const std::string& userName);
 protected:
  boost::shared_ptr< ::apache::thrift::protocol::TProtocol> piprot_;
  boost::shared_ptr< ::apache::thrift::protocol::TProtocol> poprot_;
  ::apache::thrift::protocol::TProtocol* iprot_;
  ::apache::thrift::protocol::TProtocol* oprot_;
};

class ClientServiceProcessor : public ::apache::thrift::TDispatchProcessor {
 protected:
  boost::shared_ptr<ClientServiceIf> iface_;
  virtual bool dispatchCall(::apache::thrift::protocol::TProtocol* iprot, ::apache::thrift::protocol::TProtocol* oprot, const std::string& fname, int32_t seqid, void* callContext);
 private:
  typedef  void (ClientServiceProcessor::*ProcessFunction)(int32_t, ::apache::thrift::protocol::TProtocol*, ::apache::thrift::protocol::TProtocol*, void*);
  typedef std::map<std::string, ProcessFunction> ProcessMap;
  ProcessMap processMap_;
  void process_IncomingMessage(int32_t seqid, ::apache::thrift::protocol::TProtocol* iprot, ::apache::thrift::protocol::TProtocol* oprot, void* callContext);
  void process_UserConnected(int32_t seqid, ::apache::thrift::protocol::TProtocol* iprot, ::apache::thrift::protocol::TProtocol* oprot, void* callContext);
  void process_UserDisconnected(int32_t seqid, ::apache::thrift::protocol::TProtocol* iprot, ::apache::thrift::protocol::TProtocol* oprot, void* callContext);
 public:
  ClientServiceProcessor(boost::shared_ptr<ClientServiceIf> iface) :
    iface_(iface) {
    processMap_["IncomingMessage"] = &ClientServiceProcessor::process_IncomingMessage;
    processMap_["UserConnected"] = &ClientServiceProcessor::process_UserConnected;
    processMap_["UserDisconnected"] = &ClientServiceProcessor::process_UserDisconnected;
  }

  virtual ~ClientServiceProcessor() {}
};

class ClientServiceProcessorFactory : public ::apache::thrift::TProcessorFactory {
 public:
  ClientServiceProcessorFactory(const ::boost::shared_ptr< ClientServiceIfFactory >& handlerFactory) :
      handlerFactory_(handlerFactory) {}

  ::boost::shared_ptr< ::apache::thrift::TProcessor > getProcessor(const ::apache::thrift::TConnectionInfo& connInfo);

 protected:
  ::boost::shared_ptr< ClientServiceIfFactory > handlerFactory_;
};

class ClientServiceMultiface : virtual public ClientServiceIf {
 public:
  ClientServiceMultiface(std::vector<boost::shared_ptr<ClientServiceIf> >& ifaces) : ifaces_(ifaces) {
  }
  virtual ~ClientServiceMultiface() {}
 protected:
  std::vector<boost::shared_ptr<ClientServiceIf> > ifaces_;
  ClientServiceMultiface() {}
  void add(boost::shared_ptr<ClientServiceIf> iface) {
    ifaces_.push_back(iface);
  }
 public:
  void IncomingMessage(const std::string& message, const std::string& senderName, const bool isBroadcast) {
    size_t sz = ifaces_.size();
    size_t i = 0;
    for (; i < (sz - 1); ++i) {
      ifaces_[i]->IncomingMessage(message, senderName, isBroadcast);
    }
    ifaces_[i]->IncomingMessage(message, senderName, isBroadcast);
  }

  void UserConnected(const std::string& userName) {
    size_t sz = ifaces_.size();
    size_t i = 0;
    for (; i < (sz - 1); ++i) {
      ifaces_[i]->UserConnected(userName);
    }
    ifaces_[i]->UserConnected(userName);
  }

  void UserDisconnected(const std::string& userName) {
    size_t sz = ifaces_.size();
    size_t i = 0;
    for (; i < (sz - 1); ++i) {
      ifaces_[i]->UserDisconnected(userName);
    }
    ifaces_[i]->UserDisconnected(userName);
  }

};

// The 'concurrent' client is a thread safe client that correctly handles
// out of order responses.  It is slower than the regular client, so should
// only be used when you need to share a connection among multiple threads
class ClientServiceConcurrentClient : virtual public ClientServiceIf {
 public:
  ClientServiceConcurrentClient(boost::shared_ptr< ::apache::thrift::protocol::TProtocol> prot) {
    setProtocol(prot);
  }
  ClientServiceConcurrentClient(boost::shared_ptr< ::apache::thrift::protocol::TProtocol> iprot, boost::shared_ptr< ::apache::thrift::protocol::TProtocol> oprot) {
    setProtocol(iprot,oprot);
  }
 private:
  void setProtocol(boost::shared_ptr< ::apache::thrift::protocol::TProtocol> prot) {
  setProtocol(prot,prot);
  }
  void setProtocol(boost::shared_ptr< ::apache::thrift::protocol::TProtocol> iprot, boost::shared_ptr< ::apache::thrift::protocol::TProtocol> oprot) {
    piprot_=iprot;
    poprot_=oprot;
    iprot_ = iprot.get();
    oprot_ = oprot.get();
  }
 public:
  boost::shared_ptr< ::apache::thrift::protocol::TProtocol> getInputProtocol() {
    return piprot_;
  }
  boost::shared_ptr< ::apache::thrift::protocol::TProtocol> getOutputProtocol() {
    return poprot_;
  }
  void IncomingMessage(const std::string& message, const std::string& senderName, const bool isBroadcast);
  void send_IncomingMessage(const std::string& message, const std::string& senderName, const bool isBroadcast);
  void UserConnected(const std::string& userName);
  void send_UserConnected(const std::string& userName);
  void UserDisconnected(const std::string& userName);
  void send_UserDisconnected(const std::string& userName);
 protected:
  boost::shared_ptr< ::apache::thrift::protocol::TProtocol> piprot_;
  boost::shared_ptr< ::apache::thrift::protocol::TProtocol> poprot_;
  ::apache::thrift::protocol::TProtocol* iprot_;
  ::apache::thrift::protocol::TProtocol* oprot_;
  ::apache::thrift::async::TConcurrentClientSyncInfo sync_;
};

#ifdef _WIN32
  #pragma warning( pop )
#endif

} // namespace

#endif
